
CoCoALib - Bug #1705

ProgressReporter: prepare for new loop?

24 Oct 2022 15:15 - John Abbott

Status: In Progress Start date: 24 Oct 2022

Priority: Normal Due date:  

Assignee: John Abbott % Done: 80%

Category: Improving Estimated time: 0.00 hour

Target version: CoCoALib-0.99880 Spent time: 1.45 hour

Description

I have a program with 3 loops, and would like to have progress info about each loop.

The 1st loop is very fast; the 2nd loop is quite a bit slower; and the 3rd loop is slower still.

All 3 loops do the same number of iterations.

My idea was to use a single ProgressReporter object for all 3 loops,

but it does not report anything for the slower loops.

Fix this!

History

#1 - 24 Oct 2022 15:18 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

A likely cause is that the frequency of proper time checks is too low (because of the very fast iters of the 1st loop).

Two obvious possible fixes:

(A) impose a lower upper bound on the frequency between proper checks

(B) offer a PrepareForNewLoop function (similar to CpuTimeLimit)

At the moment I prefer (B) but its does require cooperation from the user.

Maybe I should do both?

Or is the cause other than what I believe?

#2 - 03 Nov 2022 14:31 - Anna Maria Bigatti

John Abbott wrote:

A likely cause is that the frequency of proper time checks is too low (because of the very fast iters of the 1st loop).

Two obvious possible fixes:

(A) impose a lower upper bound on the frequency between proper checks

(B) offer a PrepareForNewLoop function (similar to CpuTimeLimit)

At the moment I prefer (B) but its does require cooperation from the user.

Maybe I should do both?

Or is the cause other than what I believe?
I also prefer (B).  Maybe ResetForNewLoop?

#3 - 04 Nov 2022 13:45 - John Abbott

- Assignee set to John Abbott

- % Done changed from 10 to 50

I have revised the impl -- it now works better.

Much of this code is quite similar to CpuTimeLimit.

The common part should be abstracted.

#4 - 10 Mar 2023 17:40 - John Abbott

- Target version changed from CoCoALib-0.99850 to CoCoALib-0.99880

- % Done changed from 50 to 80

#5 - 21 Mar 2023 05:27 - John Abbott

I am not so happy with the name myPrepareForLoop.

Is there a better name?

#6 - 25 Apr 2024 21:40 - John Abbott

Maybe just myReset?  Or is that too vague?  It is short, which I like.

So far we have been using myPrepareForNewLoop for over a year... well, maybe it has not been used much?
